/*
  logparser v0.01 ~byuu
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned char  uint8;
typedef unsigned short uint16;
typedef unsigned long  uint32;

uint8 *mask_table;

bool _error;
inline uint8 htoi(uint8 h) {
  if(h >= '0' && h <= '9')return h - '0';
  if(h >= 'A' && h <= 'F')return h - 'A' + 0x0a;
  if(h >= 'a' && h <= 'f')return h - 'a' + 0x0a;
  _error = true;
  return 0;
}

bool bit_set(uint32 addr) {
  return !!(mask_table[(addr >> 3) & 0x1fffff] & (0x80 >> (addr & 7)));
}

void set_bit(uint32 addr) {
  mask_table[(addr >> 3) & 0x1fffff] |= 0x80 >> (addr & 7);
}

int main(int argc, char *argv[]) {
FILE *fp, *wr;
char hexaddr[8], line[4096];
  if(argc >= 2) {
    fp = fopen(argv[1], "rb");
    if(!fp) {
      printf("Error opening log file [%s]\n", argv[1]);
      exit(0);
    }
  } else {
    fp = fopen("trace.log", "rb");
    if(!fp) {
      printf("Error opening log file [trace.log]\n");
      exit(0);
    }
  }

  wr = fopen("trace.txt", "wb");
  if(!wr) {
    printf("Error opening output file [trace.txt]\n");
    exit(0);
  }

  fseek(fp, 0, SEEK_END);
int fsize = ftell(fp);
  fseek(fp, 0, SEEK_SET);

  mask_table = (uint8*)malloc(0x200000);
  memset(mask_table, 0, 0x200000);
uint32 addr, z;
  while(!feof(fp)) {
    fread(hexaddr, 1, 6, fp);
    _error = false;
    addr  = htoi(hexaddr[0]) << 20;
    addr |= htoi(hexaddr[1]) << 16;
    addr |= htoi(hexaddr[2]) << 12;
    addr |= htoi(hexaddr[3]) <<  8;
    addr |= htoi(hexaddr[4]) <<  4;
    addr |= htoi(hexaddr[5]);
    if(!bit_set(addr) || _error == true) {
      set_bit(addr);
      memcpy(line, hexaddr, 6);
      z = 6;
      while(!feof(fp) && z < 4095) {
        line[z] = fgetc(fp);
        if(line[z] == '\n')break;
        z++;
      }
      fwrite(line, 1, z + 1, wr);
    } else {
      while(!feof(fp)) {
        if(fgetc(fp) == '\n')break;
      }
    }
  }

  fclose(fp);
  fclose(wr);
  return 0;
}
